/*

 string_c

 String functions not (currently) in the library

 Date		Author		Comments
 ----		------		--------
 12/03/1998	A.D.Ives	New module added for v1.06

 1.07
 ----
 12/03/1998	A.D.Ives	Calls strncmp() instead of strcmp() to
				fix problem where it only found str2 at
				the end of str1. (Thanks to Dave Walker
				for pointing this one out).

*/

#include <string.h>


char *strrstr(char *str1, char *str2) {

  /* Find the rightmost occurrence of str2 in str1 */

  char *ptr, first ;
  int len2 ;

  if ( !*str1 || !*str2 )
    return NULL ;
  first= *str2 ;
  len2= strlen(str2) ;
  for ( ptr= str1 + strlen(str1) - len2 ; ptr >= str1 ; ptr-- ) {
    if ( *ptr == first ) {
      if ( strncmp(ptr, str2, len2) == 0 )
	return ptr ;
    }
  }
  return NULL ;
}
